/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file JsonLevelReader.h
\author Zach Dolph  
\par E-mail: z.dolph\@digipen.edu
\par Project: Boat Game
\date 2/7/2017
\brief
Interface file for the Json level reader which reads and level files and 
          creates objects
*/
/*****************************************************************************/
#pragma once
#ifndef JSON_LEVEL_READER_H
#define JSON_LEVEL_READER_H

#include <json\json.h>

class GameObjectManager;
class Object;

class DependencyError : std::exception
{
public:
  std::string dependencyName;
  DependencyError(std::string name) : dependencyName(name) {};
};

class JsonLevelReader
{
public:
  static bool CheckDependencies(Json::Value object);
  static bool ValidateComponents(Json::Value object);
  static Object * BuildObject(Json::Value object, std::string name, GameObjectManager * objManager);
private:

};

#endif
