/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file LevelSwitcher.cpp
\author yourname
\par E-mail: youremail
\par Project: Boat Game
\date 12/8/2016 11:27:15 AM
\brief

\par
Functions Include:
-
*/
/*****************************************************************************/

#include "LevelSwitcher.h"
#include "Collider.h"
#include "Object.h"
#include "SpaceManager.h"
#include "InputManager.h"
#include "AdaptiveMusic.h"


LevelSwitcher::LevelSwitcher(StateType state = WIN_SCREEN) : _nextState(state), 
_fromFile(false), Component("LevelSwitcher"), _transitionCreated(false)
{
}

LevelSwitcher::LevelSwitcher(std::string fileName) : _levelFile(fileName), 
_fromFile(true), Component("LevelSwitcher"), _transitionCreated(false)
{

}

void LevelSwitcher::Update()
{
  if (_transitionCreated)
    return;
  Collider * collider = Owner().Find<Collider>();
  if (collider->Collided())
  {
    for each(CollisionInfo info in collider->GetCollisionList())
    {
      if (info.GetObject()->Find<Collider>()->GetCollisionGroup() == "Player")
      {
        Switch();
        return;
      }
    }
  }
  if (InputManager::Instance()->isKeyDown(SDL_SCANCODE_LCTRL) && InputManager::Instance()->IsKeyPressed(SDL_SCANCODE_N))
  {
    Switch();
    return;
  }
}

void LevelSwitcher::Switch()
{
  AdaptiveMusic::track = !AdaptiveMusic::track;
  if (!_transitionCreated) {
    if (_fromFile) {
      TransitionInfo transition_info(1.0f, 3.5f, _nextState, _levelFile);
      Global::SpaceManager::Add(transition_info);
    }
    else {
      TransitionInfo transition_info(1.0f, 3.5f, _nextState);
      Global::SpaceManager::Add(transition_info);
    }
  }
  _transitionCreated = true;
}

Component * CreateLevelSwitcherComponent(Json::Value value)
{
  if (value["level"].asString() != "")
  {
    return new LevelSwitcher(value["level"].asString());
  }
  return new LevelSwitcher();
}