/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file Line.cpp
\author Gabe Miller
\par E-mail: g.miller\@digipen.edu
\par Project: Boat Game
\date 4/13/2017 2:06:41 PM
\brief

\par
Functions Include:
-
*/
/*****************************************************************************/

#include "Line.h"
#include "Object.h"
#include "SpritePool.h"
#include "TexturePool.h"
#include "ShaderPool.h"
#include "Vec2Math.h"

Line::Line() : Component("Line")
{

}


void Line::Update()
{
  float length = glm::distance(start, end);
  Owner().GetTransform()->Scale() = glm::vec3(length, width, 1);
  Owner().GetTransform()->Translation() = (start + end) * 0.5f;
  Owner().GetTransform()->Rotation() = Math::AngleBetweenSlow(glm::vec2(end - start), glm::vec2(1, 0)) * glm::sign(glm::dot(glm::vec2(end - start), glm::vec2(0, 1)));
}

Component * CreateLineComponent(Json::Value value)
{
  return new Line();
}