/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#include <GL\glew.h>
#include <SDL.h>
#include <SDL_opengl.h>
#include <iostream>

#include "Context.h"
#include "Graphics.h"
#include "InputManager.h"
#include "GraphicPool.h"
#include "TexturePool.h"
#include "ShaderPool.h"
#include "Transform.h"
#include "GameObjectManager.h"
#include "Sprite.h"
#include "Shader.h"
#include "LogoScreen.h"
#include "SpaceManager.h"
#include "AudioEngine.h"

#include "Time.h"


namespace
{
  Transform * logoTran;
  float time = 0;
}

void LogoScreen::Allocate()
{
  audEngine.PlayEvent(audEngine.GetMusicEvent("LogoSplash"));
}
void LogoScreen::Load()
{
  (**_space).GetCamera()->SetHeight(30.0f);

	// digipen logo bruh
	Object * logo = _objectManager.CreateArchetypeObjectAtPosition("recursivelogo", glm::vec3(-1.5f, 0.0f, 0.0f));
  logoTran = logo->GetTransform();
  logoTran->Scale() = glm::vec3(20, 20, 0);
}
bool LogoScreen::Update()
{
	if (logoTran->GetScale().x < 30.0f)
	{
		logoTran->Scale() = glm::vec3(logoTran->GetScale().x + Time::DT() * 7, 
                                  logoTran->GetScale().y + Time::DT() * 7, 
                                  logoTran->GetScale().z);
	}
		

	//logoTran->Scale() = glm::vec3(logoTran->GetScale().x - 0.1f, logoTran->GetScale().y - 0.1f, logoTran->GetScale().z);


  time += Time::DT();

  // These are all the buttons we need to support to skip logo with
  if (
    time > 3.5f ||
    TheInputManager::Instance()->IsKeyPressed(SDL_SCANCODE_SPACE) || TheInputManager::Instance()->IsKeyPressed(SDL_SCANCODE_RETURN) 
    || TheInputManager::Instance()->IsKeyPressed(SDL_SCANCODE_ESCAPE)
    || TheInputManager::Instance()->isMousePressed(mouse_buttons::LEFT) || TheInputManager::Instance()->isMousePressed(mouse_buttons::RIGHT)
    || (InputManager::Instance()->getJoystickSize() > 0 && (InputManager::Instance()->getButtonState(0, SDL_CONTROLLER_BUTTON_A) || InputManager::Instance()->getButtonState(0, SDL_CONTROLLER_BUTTON_START)))
    || (InputManager::Instance()->getJoystickSize() > 1 && (InputManager::Instance()->getButtonState(1, SDL_CONTROLLER_BUTTON_A) || InputManager::Instance()->getButtonState(1, SDL_CONTROLLER_BUTTON_START)))
    )
  {
    (**_space).Change(MENU_MAIN);
    audEngine.StopEvent(audEngine.GetMusicEvent("LogoSplash"));
  }


	return true;
}

