/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#include "LoseScreen.h"
#include "InputManager.h"
#include "Space.h"
#include "Graphics.h"
#include "AudioEngine.h"
#include "SpaceManager.h"


std::string LoseScreen::level = "Resources/levels/Level1.lvl";


void LoseScreen::Allocate()
{
  _objectManager.CreateArchetypeObjectAtPosition("loseScreen", glm::vec3(0, 0, 0));
  Graphics::SetClearColor(0.1f, 0.1f, 0.1f, 1);

  audEngine.PlayEvent(audEngine.GetMusicEvent("PlayerLose"));
}

bool LoseScreen::Update()
{
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_RETURN) ||
      TheInputManager::Instance()->getButtonState(0, SDL_CONTROLLER_BUTTON_A))
  {
    Global::SpaceManager::RemoveAll();
    Global::SpaceManager::Add(level, 30);

    audEngine.StopEvent(audEngine.GetMusicEvent("PlayerLose"));
  }

  return true;
}