/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#include "SpaceManager.h"
#include "Space.h"
#include "StateFactory.h"
#include "InputManager.h"
#include "GameObjectManager.h"
#include "Transform.h"
#include "Sprite.h"
#include "LevelOne.h"
#include "AudioEngine.h"

#include "MainMenu.h"

#include <fstream>
#include "JsonLevelReader.h"

#include "Camera.h"

#include "RendererWater.h"

#include "Color.h"
#include "Time.h"
#include <glm\gtc\constants.hpp>

namespace
{
  Transform * menuSelecTran;
  bool pressedUp = false;
  bool pressedDown = false;
  float time = 0;
  //Object * cursor;
}

void MenuMain::Allocate()
{
  RendererWater::SetFrequency(0.3);
  RendererWater::SetWorldSize(glm::vec2(20, 20));
  time = 0;
  std::ifstream inputFile;
  inputFile.open("Resources/levels/main_menu.lvl");
  Json::Reader reader;
  Json::Value value;
  bool parsingSuccessful = reader.parse(inputFile, value);
  // Check to make sure the file was read correctly.
  if (!parsingSuccessful)
  {
    std::cout << "parsing failed";
    std::cout << reader.getFormattedErrorMessages();
  }
  else
  {
    for each(Json::Value object in value["ArchetypeObjects"])
    {
      std::cout << object;
      std::string name = object["Archetype"].asString();
      glm::vec3 pos;
      if (object["Position"].size() >= 3)
        pos = glm::vec3(object["Position"][0].asFloat(), object["Position"][1].asFloat(), object["Position"][2].asFloat());
      _objectManager.CreateArchetypeObjectAtPosition(name, pos);
    }
    for each(Json::Value object in value["Objects"])
    {
      JsonLevelReader::CheckDependencies(object);
      JsonLevelReader::ValidateComponents(object);
      JsonLevelReader::BuildObject(object, object["Name"].asString(), &_objectManager);
    }
  }
}

void MenuMain::Load()
{
 
}


bool MenuMain::Update()
{
  time += Time::DT();
  float value = (glm::sin((time * 0.5) - glm::half_pi<float>()) + 1.2f) * 0.25f;
  RendererWater::SetPeakColor(glm::vec3(0, 0.6, 1) * value + HSVToRGB(glm::vec3(time * 30, 1 , value)));
  RendererWater::SetTroughColor(glm::vec3(-0.5f, -0.5f, -0.5f));
  return true;
}

void MenuMain::Free()
{
}
