/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file MenuCursor.cpp
\author Gabe Miller
\par E-mail: g.miller\@digipen.edu
\par Project: Boat Game
\date 4/18/2017 11:02:03 AM
\brief

\par
Functions Include:
-
*/
/*****************************************************************************/

#include "MenuCursor.h"

#include "Context.h"
#include "InputManager.h"
#include "Object.h"
#include "GameObjectManager.h"
#include "Space.h"

MenuCursor::MenuCursor() : Component("MenuCursor")
{
  Context::HideCursor(true);
}
void MenuCursor::Update()
{
  glm::vec2 mousePos = *InputManager::Instance()->getMousePosition();
  (**Owner().ObjectManager()->Space()).ScreenToWorld(mousePos);
  Owner().GetTransform()->Translation() = glm::vec3(mousePos, 5) + glm::vec3(0.5f, -1, 0);
}

Component * CreateMenuCursorComponent(Json::Value value)
{
  return new MenuCursor();
}