/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#include <iostream>

#include "SpaceManager.h"
#include "Space.h"
#include "StateFactory.h"
#include "InputManager.h"
#include "GameObjectManager.h"
#include "Transform.h"
#include "Sprite.h"
#include "LevelOne.h"
#include "AudioEngine.h"
#include "MenuPause.h"
#include <fstream>
#include "JsonLevelReader.h"
#include "Camera.h"

namespace
{
  Transform * pauseSelecTran;
  //int buttonPressed;
  bool confirmation;
  Object * confirmMessage;
}

void MenuPause::Allocate()
{

  std::ifstream inputFile;
  inputFile.open("Resources/levels/pause_menu.lvl");
  Json::Reader reader;
  Json::Value value;
  bool parsingSuccessful = reader.parse(inputFile, value);
  // Check to make sure the file was read correctly.
  if (!parsingSuccessful)
  {
    std::cout << "parsing failed";
    std::cout << reader.getFormattedErrorMessages();
  }
  else
  {
    for each(Json::Value object in value["ArchetypeObjects"])
    {
      std::cout << object;
      std::string name = object["Archetype"].asString();
      glm::vec3 pos;
      if (object["Position"].size() >= 3)
        pos = glm::vec3(object["Position"][0].asFloat(), object["Position"][1].asFloat(), object["Position"][2].asFloat());
      _objectManager.CreateArchetypeObjectAtPosition(name, pos);
    }
    for each(Json::Value object in value["Objects"])
    {
      JsonLevelReader::CheckDependencies(object);
      JsonLevelReader::ValidateComponents(object);
      JsonLevelReader::BuildObject(object, object["Name"].asString(), &_objectManager);
    }
  }

}

void MenuPause::Free()
{
  audEngine.SetEventParameter(audEngine.GetMusicEvent("LevelOne"),
    "Pause", 0);
  audEngine.SetEventParameter("event:/Music/Level2BGM",
    "Pause", 0);
  
}

void MenuPause::Load()
{
  //buttonPressed = 0;
}


bool MenuPause::Update()
{

  return true;
}

