#pragma once
/*****************************************************************************/
/*!
\file MenuSystem.h
\author Gabe Miller
\par E-mail: g.miller\@digipen.edu
\par Project: Boat Game
\date 2/24/2017 3:05:47 PM
\brief
*/
/*****************************************************************************/

#ifndef MenuSystem_H
#define MenuSystem_H

#include "Component.h"
#include <glm\glm.hpp>

/*****************************************************************************/
/*!
\class MenuSystem
\brief


\par
	Operations include:
	-

\deprecated
	-

\bug
	-
*/
/*****************************************************************************/
class MenuSystem : public Component
{

  typedef void (MenuSystem::*confirmationFunction)(void);
public:
  MenuSystem(glm::vec2 basePos, glm::vec2 offset);
  void Init();
  void Update();
  void AddMenuOption(std::string option);
private:
  glm::vec2 _cursorBasePos;
  glm::vec2 _cursorOffset;
  bool _transition;
  Object * _cursor;
  std::vector<std::string> _menuOptions;
  bool _confirmation;
  int _buttonPosition;
  Object * _confirmMessage;
  bool _firstFrame;
  confirmationFunction _confirmFunction;

  void StartGame();
  void ControlsScreen();
  void SettingsMenu();
  void CreditsScreen();
  void ConfirmQuit();
  void Quit();
  void MainMenu();
  void ResumeGame();
  void Restart();


  // Input "Macros"
  int MenuDirection();
  void MenuButtonSelected();
  int MousePosition();
};

Component * CreateMenuSystemComponent(Json::Value value);

#endif