/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file Mine.cpp
\author Gabe Miller
\par E-mail: g.miller\@digipen.edu
\par Project: Boat Game
\date 3/16/2017 4:25:30 PM
\brief

\par
Functions Include:
-
*/
/*****************************************************************************/

#include "Mine.h"
#include "Collider.h"
#include "Object.h"
#include "GameObjectManager.h"
#include "AudioEngine.h"
#include "Transform.h"

Mine::Mine() : Component("Mine")
{}

void Mine::Init()
{
  Owner().SubscribeCallback(EnemyDamaged::DeathID, std::bind(&Mine::Dead, this, std::placeholders::_1));
}

void Mine::Update()
{
  for each(CollisionInfo info in Owner().Find<Collider>()->GetCollisionList())
  {
    if (info.GetObject()->Find<Collider>() && info.GetObject()->Find<Collider>()->GetCollisionGroup() == "Player")
    {
      Owner().DispatchEvent(&EnemyDamaged(1, info));
    }
  }
}


void Mine::Dead(Event * deadEvent)
{
  Owner().ObjectManager()->CreateArchetypeObjectAtPosition("explosion", Owner().GetTransform()->GetTranslation());
  audEngine.PlayEvent("event:/SFX/enemyexplosion");
}

Component * CreateMineComponent(Json::Value value)
{
  return new Mine();
}