/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file Particle.cpp
\author Sukanya Ratanotayanon
\par E-mail: sratanot@sci.tu.ac.th
\par Project: Boat Game
\date 2/11/2017 10:51:14 PM
\brief

\par
Functions Include:
-
*/
/*****************************************************************************/

#include "Particle.h"
#include <iostream>

Particle::Particle( float life, float angle, float speed,float size)
  : _life(life), _initialLife (life), _speed(speed), _angleRad (angle), _size(size), _initialSize(size)
{
}

Particle::~Particle()
{
}
void Particle::UpdateProperties(float life, float angle, float speed, glm::vec3 position, float size, float alpha)
{
  _life = life;
  _angleRad = angle;
  _speed = speed;
  _transform.SetTranslation( position);
  _size = size;
  _transform.SetScale ( glm::vec3(size,size, 1.0f));
  _alpha = alpha;

}
void Particle::Update(float time)
{

  ///**
  //  The emiter should draw the whole thing but lets leave it this way
  //*/
  //if (_life > 0) {
  //  float deltaTime = time;
  //  float x = _transform.GetTranslation().x + _speed * deltaTime * cosf(_angleRad);
  //  float y = _transform.GetTranslation().y + _speed * deltaTime * sin(_angleRad);
  //  _transform.Translation() = glm::vec3(x, y, 0.0f);
  //  _transform.Scale() = glm::vec3(_size * _alpha, _size* _alpha, 1.0f);
  //  //if (_transform.GetScale().x > 0.35 || _transform.GetScale().y > 0.35) {
  //  //  std::cout << "size " << _transform.GetScale().x << " " << _transform.GetScale().y << std::endl;
  //  //}
  //  _life -= deltaTime;
  //  _alpha = _life / _initialLife;
  //}
}

void Particle::Init(const glm::vec3 &initPos )
{
  _transform.SetTranslation ( initPos);
  _life = _initialLife;
  _alpha = 1;
  _size = _initialSize;

}

float Particle::getLife()
{
  return _life;
}

float Particle::getSpeed()
{
  return _speed;
}

float Particle::getAngleRad()
{
  return _angleRad;
}

float Particle::getAlpha()
{
  return _alpha;
}

float Particle::getSize()
{
  return _size;
}

float Particle::getInitialLife()
{
  return _initialLife;
}

float Particle::getInitialSize()
{
  return _initialSize;
}

Transform & Particle::getTransform()
{
  return _transform;
}


