/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file Particle.h
\author Sukanya Ratanotayanon
\par E-mail: sukanya_r@sci.tu.ac.th
\par Project: Boat Game
\date 2/11/2017 10:51:01 PM
\brief
*/
/*****************************************************************************/

#ifndef PARTICLE_H
#define PARTICLE_H

#include "Transform.h"

/*****************************************************************************/
/*!
\class Particle
\brief


\par
	Operations include:
	-

\deprecated
	-

\bug
	-
*/
/*****************************************************************************/
class Particle 
{
public:
  Particle( float life, float angle, float speed,float size);
  ~Particle();
  
  void Update(float time);
  void Init(const glm::vec3 &initPos);
  friend class Emitter;
  float getLife();
  float getSpeed();
  float getAngleRad();
  float getAlpha();
  float getSize();
  float getInitialLife();
  float getInitialSize();
  Transform & getTransform();

  void UpdateProperties(float life, float angle, float speed, glm::vec3 position, float size,float alpha);
private:

  //! This is the Transform component attached to the object this Sprite is
  // attached to.
  float _life;
  float _speed;
  float _angleRad;
  float _alpha;
  float _size;
  float _initialLife;
  float _initialSize;
  Transform _transform;
};


#endif //!PARTICLE_H