/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file RenderWater.h
\author Connor Deakin
\par E-mail: connor.deakin\@digipen.edu
\par Project: X-Craft
\date 09/04/2017
*/
/*****************************************************************************/

#ifndef RENDERERWATER_H
#define RENDERERWATER_H

#include <GLM/glm/vec3.hpp>
#include <GLM/glm/vec2.hpp>

/*****************************************************************************/
/*!
\class RendererWater
\brief
  Used for rendering water across the entire screen.
*/
/*****************************************************************************/
class RendererWater
{
public:
  static void Render();
  static void SetCameraPosition(const glm::vec2 & camera_position);
  static void SetFrequency(float new_frequency);
  static void SetSpeedMultiple(float new_speed_multiple);
  static void SetWorldSize(const glm::vec2 & new_world_size);
  static void SetLayers(int new_layers);
  static void SetPeakColor(const glm::vec3 & new_peak_color);
  static void SetTroughColor(const glm::vec3 & new_trough_color);
private:
  RendererWater() {}
};

#endif // !RENDERERWATER_H

