/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#include "GameObjectManager.h"
#include "ShaderPool.h"
#include "GraphicPool.h"
#include "TexturePool.h"
#include "AudioEngine.h"
#include "InputManager.h"
#include "Physics.h"
#include "CircleCollider.h"
#include "ArchetypeManager.h"
#include "Transform.h"
#include "SpritePool.h"
#include "CharacterController.h"
#include "SandboxGraphics.h"
#include "Camera.h"


#include "SpaceManager.h"
#include "MenuPause.h"

#include "GlobalTransform.h"
#include "GlobalCamera.h"

namespace
{
  Transform * t;
  Transform * tran2;
  Transform * tc1;
  Transform * tc2;

  Object * camera1;
  Object * camera2;

  Camera * cam1p;
  Camera * cam2p;
}

void SandboxGraphics::Allocate()
{
  const Texture * t1 = TexturePool::Add("Resources/Visual/Environment/water.png");
  const Texture * t2 = TexturePool::Add("Resources/Visual/Craft/Carrier/red.png");
  const Texture * t3 = TexturePool::Add("Resources/Visual/Debug/camera.png");

  TextureSprite * cam_sprite

  //camera1
  camera1 = State::_objectManager.CreateObject("camera1");
  camera1->SetSprite(Sprit)
  tc1 = camera1->GetTransform();
  cam1p = (Camera *)camera1->Add(new Camera(&ShaderPool::Texture()));
  camera1->Init();
  //camera2
  camera2 = State::_objectManager.CreateObject("camera2");
  tc2 = (Transform *)camera2->Add(new Transform());
  cam2p = (Camera *)camera2->Add(new Camera(&ShaderPool::Texture()));
  camera2->Add(new Sprite(&ShaderPool::Texture(), &GraphicPool::Texture(), t3));
  camera2->Init();

  //water
  Object * go1 = State::_objectManager.CreateObject("go1");
  tran2 = (Transform *)go1->Add(new Transform());
  go1->Add(new Sprite(&ShaderPool::Texture(), &GraphicPool::Texture(), t1));
  go1->Init();
  //ship
  Object * go2 = State::_objectManager.CreateObject("go2");
  t = (Transform *)go2->Add(new Transform());
  go2->Add(new Sprite(&ShaderPool::Texture(), &GraphicPool::Texture(), t2));
  go2->Init();
}

void SandboxGraphics::Load()
{

  tc2->Translation() = glm::vec3(-5.0f, 0.0f, 0.0f);
  tc1->SetTranslation(glm::vec3(5.0f, 0.0f, 0.0f));
  t->Scale() = glm::vec3(2.0f, 2.0f, 1.0f);
  tran2->Scale() = glm::vec3(20.0, 20.0, 1.0f);
}

bool SandboxGraphics::Update()
{
  // rotate camera
  tc1->Rotation() = tc1->Rotation() + 0.001f;
  // Change Camera's
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_ESCAPE))
    return false;
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_1))
    (**_space).SetCamera(cam2p);
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_2))
    (**_space).SetCamera(cam1p);
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_3))
    Global::Camera::Deactivate();
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_4))
    Global::Camera::Reset();
  //Move camera
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_W))
    tc2->Translation() = glm::vec3(tc2->GetTranslation().x, tc2->GetTranslation().y + 0.01f, 1.0f);
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_S))
    tc2->Translation() = glm::vec3(tc2->GetTranslation().x, tc2->GetTranslation().y - 0.01f, 1.0f);
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_D))
    tc2->Translation() = glm::vec3(tc2->GetTranslation().x + 0.01f, tc2->GetTranslation().y, 1.0f);
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_A))
    tc2->Translation() = glm::vec3(tc2->GetTranslation().x - 0.01f, tc2->GetTranslation().y, 1.0f);
  // Stretch ship
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_I))
    t->Scale() = glm::vec3(t->GetScale().x, t->GetScale().y + 0.01f, 1.0f);
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_K))
    t->Scale() = glm::vec3(t->GetScale().x, t->GetScale().y - 0.01f, 1.0f);
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_L))
    t->Scale() = glm::vec3(t->GetScale().x + 0.01f, t->GetScale().y, 1.0f);
  if (TheInputManager::Instance()->isKeyDown(SDL_SCANCODE_J))
    t->Scale() = glm::vec3(t->GetScale().x - 0.01f, t->GetScale().y, 1.0f);

  return true;
}