/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#ifndef SETTINGS_SCREEN_H
#define SETTINGS_SCREEN_H

#include "State.h"

class SettingsMenu : public State
{
public:
  SettingsMenu();
  virtual void Allocate();
  virtual void Load();
  virtual bool Update();
private:
  //! Possible options
  enum OPTION
  {
    FULLSCREEN,
    MASTER_VOLUME,
    MUSIC_VOLUME,
    SFX_VOLUME,
    BACK
  };
  void SetOption();
  void FullscreenUpdate();
  void MasterVolumeUpdate();
  void MusicVolumeUpdate();
  void SFXVolumeUpdate();
  void BackUpdate();
  float Clamp(float min, float max, float val);
  //! The current option that the cursor is on.
  glm::vec2 _prevMouseLoc;
  glm::vec2 _mouseLoc;
  OPTION _currentOption;
  OPTION _previousOption;
  Transform * _masterVSlider;
  Transform * _musicVSlider;
  Transform * _sfxVSlider;
  float _masterDistance;
  float _musicDistance;
  float _sfxDistance;

};

#endif
