#version 330 core

in vec3 position;
in vec2 in_texCoord;

uniform uvec2 totalFrames = uvec2(1, 1);
uniform uvec2 currentFrame = uvec2(0, 0);
out vec2 texCoord;

uniform mat4 transformation = mat4(1.0f, 0.0f, 0.0f, 0.0f,
                                   0.0f, 1.0f, 0.0f, 0.0f,
                                   0.0f, 0.0f, 1.0f, 0.0f,
                                   0.0f, 0.0f, 0.0f, 1.0f);

void main()
{
  gl_Position = transformation * vec4(position, 1.0);
  vec2 frame_size = vec2(1.0f / totalFrames.x, 1.0f / totalFrames.y);
  texCoord = vec2(in_texCoord.x, 1.0f - in_texCoord.y);
  texCoord = vec2(texCoord.x / totalFrames.x, texCoord.y / totalFrames.y);
  texCoord = vec2(texCoord.x + frame_size.x * currentFrame.x,
                  texCoord.y + frame_size.y * currentFrame.y);
}
