/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file ShaderScreen.h
\author Connor Deakin
\par E-mail: connor.deakin\@digipen.edu
\par Project: Graphics
\date 24/03/2017
*/
/*****************************************************************************/

#ifndef SHADERSCREEN_H
#define SHADERSCREEN_H

#include <string>

#include "Shader.h"

/*****************************************************************************/
/*!
\class ShaderScreen
\brief
  This is the shader used to display the texture contents within a framebuffer
  to the screen.
*/
/*****************************************************************************/
class ShaderScreen : public Shader
{
  public:
    ShaderScreen(const std::string & vert, const std::string & frag);
    GLint PostionA();
    GLint TexCoordA();
    GLint ScreenU();
  private:
    //! The location of the shader's position attribute.
    GLint _position_A;
    //! The location of the shader's texCoord attribute.
    GLint _texCoord_A;
    //! The location of the shader's screen uniform.
    GLint _screen_U;
};


#endif // !SHADERSCREEN_H


