/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file ShaderWater.h
\author Connor Deakin
\par E-mail: connor.deakin\@digipen.edu
\par Project: X-Craft
\date 09/04/2017
*/
/*****************************************************************************/

#ifndef SHADERWATER_H
#define SHADERWATER_H

#include "Shader.h"

/*****************************************************************************/
/*!
\class ShaderWater
\brief
  The water shader type's class.
*/
/*****************************************************************************/
class ShaderWater : public Shader
{
public:
  ShaderWater();
  GLint PositionA() const;
  GLint TexCoordA() const;
  GLint TimeU() const;
  GLint CameraPositionU() const;
  GLint FrequencyU() const;
  GLint SpeedMultipleU() const;
  GLint WorldSizeU() const;
  GLint LayersU() const;
  GLint PeakColorU() const;
  GLint TroughColorU() const;
private:
  //! Location of position attribute.
  GLint _position_A;
  //! Location of texCoord attribute.
  GLint _texCoord_A;
  //! Location of time uniform.
  GLint _time_U;
  //! Location fo the camera position uniform.
  GLint _cameraPosition_U;
  //! Location of the frequency uniform.
  GLint _frequency_U;
  //! Location of speedMultiple uniform.
  GLint _speedMultiple_U;
  //! Location of worldSize uniform.
  GLint _worldSize_U;
  //! Location of layers uniform.
  GLint _layers_U;
  //! Location of peakColor uniform.
  GLint _peakColor_U;
  //! Location of troughColor uniform.
  GLint _troughColor_U;
};

#endif // !SHADERWATER_H
