/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file SimpleForceController.cpp
\author Gabe Miller
\par E-mail: g.miller@digipen.edu
\par Project: Boat Game
\date 11/13/2016 10:17:10 AM
\brief

\par
Functions Include:
-
*/
/*****************************************************************************/

#include "SimpleForceController.h"
#include "InputManager.h"
#include "Object.h"
#include "Physics.h"

SimpleForceController::SimpleForceController() : Component("SimpleForceController")
{

}

void SimpleForceController::Update()
{
  Physics * physics = Owner().Find<Physics>();
  float scalar = physics->GetMass() * 1;
  if (InputManager::Instance()->isKeyDown(SDL_SCANCODE_W))
  {
    physics->ApplyForce(glm::vec2(0, 1) * scalar);
  }
  if (InputManager::Instance()->isKeyDown(SDL_SCANCODE_S))
  {
    physics->ApplyForce(glm::vec2(0, -1) * scalar);
  }
  if (InputManager::Instance()->isKeyDown(SDL_SCANCODE_A))
  {
    physics->ApplyForce(glm::vec2(-1, 0) * scalar);
  }
  if (InputManager::Instance()->isKeyDown(SDL_SCANCODE_D))
  {
    physics->ApplyForce(glm::vec2(1, 0) * scalar);
  }
}