/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#include <GL\glew.h>
#include <SDL.h>
#include <SDL_opengl.h>
#include <iostream>

#include "Context.h"
#include "Graphics.h"
#include "InputManager.h"
#include "GraphicPool.h"
#include "TexturePool.h"
#include "ShaderPool.h"
#include "Transform.h"
#include "GameObjectManager.h"
#include "Sprite.h"
#include "Shader.h"
#include "SplashScreen.h"
#include "spaceID.h"
#include "Space.h"
#include "Time.h"
#include "SpaceManager.h"
#include "AudioEngine.h"

void SplashScreen::Allocate()
{
  audEngine.PlayEvent(audEngine.GetMusicEvent("DigipenLogoSplash"));
}
void SplashScreen::Load()
{
  (**_space).GetCamera()->SetHeight(30.0f);
	// digipen logo bruh
	_splashLogo = _objectManager.CreateArchetypeObjectAtPosition("digipen", glm::vec3(-1.0f, -1.0f, 0.0f));

	// fmod logo bruh
	_other = _objectManager.CreateArchetypeObjectAtPosition("fmodlogo", glm::vec3(-1.0f, -10.0f, 0.0f));
  _splashLogo->GetSprite()->SetAlpha(0.0f);
  _other->GetSprite()->SetAlpha(0.0f);
}



bool SplashScreen::Update()
{
  _stageTime += Time::DT();
  switch (_currentStage)
  {
  case SplashScreen::FADEIN:
    _splashLogo->GetSprite()->SetAlpha(_stageTime / 1.0f);
    _other->GetSprite()->SetAlpha(_stageTime / 1.0f);
    if (_stageTime > 1.0f) {
      _currentStage = STILL;
      _splashLogo->GetSprite()->SetAlpha(1.0f);
      _other->GetSprite()->SetAlpha(1.0f);
      _stageTime = 0.0f;
    }
    break;
  case SplashScreen::STILL:
    if (_stageTime > 8.0f) {
      _currentStage = FADOUT;
      _stageTime = 0.0f;
    }
    break;
  case SplashScreen::FADOUT:
    _splashLogo->GetSprite()->SetAlpha(1.0f - (_stageTime / 1.0f));
    _other->GetSprite()->SetAlpha(1.0f - (_stageTime / 1.0f));
    if (_stageTime > 1.0f) {
      (**_space).Change(LOGO_SCREEN);
      audEngine.StopEvent("event:/Music/DigipenLogoSplash");
    }
    break;
  default:
    break;
  }
  if ((TheInputManager::Instance()->IsKeyPressed(SDL_SCANCODE_SPACE) || TheInputManager::Instance()->IsKeyPressed(SDL_SCANCODE_RETURN) ||
    TheInputManager::Instance()->IsKeyPressed(SDL_SCANCODE_ESCAPE)
    || TheInputManager::Instance()->isMousePressed(mouse_buttons::LEFT) || TheInputManager::Instance()->isMousePressed(mouse_buttons::RIGHT)
    || (InputManager::Instance()->getJoystickSize() > 0 && (InputManager::Instance()->getButtonState(0, SDL_CONTROLLER_BUTTON_A) || InputManager::Instance()->getButtonState(0, SDL_CONTROLLER_BUTTON_START)))
    || (InputManager::Instance()->getJoystickSize() > 1 && (InputManager::Instance()->getButtonState(1, SDL_CONTROLLER_BUTTON_A) || InputManager::Instance()->getButtonState(1, SDL_CONTROLLER_BUTTON_START)))) &&
    _currentStage != FADOUT)
	{
    _stageTime = 0.0f;
    _currentStage = FADOUT;
	}

	return true;
}
