/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file TextureGraphic.h
\author Connor Deakin
\par E-mail: connor.deakin\@digipen.edu
\par Project: Graphics
\date 26/02/2016
\brief
  Contains the interface for the TextureGraphic. Look in at the TextureGraphic
  class for more information.
*/
/*****************************************************************************/

#ifndef TEXTUREGRAPHIC_H
#define TEXTUREGRAPHIC_H

#include <GL\glew.h>

#include "Graphic.h"

/*****************************************************************************/
/*!
\class TextureGraphic
\brief
  This is the Graphic type that is used to display simple Graphics with
  Textures to the screen.

\par Important Notes
  - Make sure to Purge the TextureGraphic once you are done using it.
*/
/*****************************************************************************/
class TextureGraphic : public Graphic
{
  public:
    TextureGraphic();
    virtual void Draw() const;
};

#endif //!TEXTUREGRAPHIC_H
