/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file TextureGraphicShader.h
\author Connor Deakin
\par E-mail: connor.deakin\@digipen.edu
\par Project: Graphics
\date 07/03/2017
\brief
  Contains the interface for the TextureGraphicShader. Look at the 
  TextureGraphicShader class for more information.
*/
/*****************************************************************************/

#ifndef TEXTUREGRAPHICSHADER_H
#define TEXTUREGRAPHICSHADER_H

#include "TextureGraphic.h"
#include "Shader.h"

/*****************************************************************************/
/*!
\class TextureGraphicShader
\brief
  Shader used for displaying a TextureGraphic.
*/
/*****************************************************************************/
class TextureGraphicShader : public Shader
{
public:
  TextureGraphicShader(const std::string & vert_file, 
                       const std::string & frag_file,
                       const TextureGraphic & texture_graphic);
  GLint PositionA() const;
  GLint TexCoordA() const;
  GLint TransformationU() const;
  GLint ColorU() const;
  GLint TextureU() const;
private:
  //! The location of the Shader's position attribute.
  GLint _position_A;
  //! The location of the Shader's texCoord attirbute.
  GLint _texCoord_A;
  //! The location of the Shader's transformation uniform.
  GLint _transformation_U;
  //! The location of the Shader's color uniform.
  GLint _color_U;
  //! The location of the shader's texture uniform.
  GLint _texture_U;
};

#endif // !DEFAULTSHADER_H
