/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file TextureSprite.h
\author Connor Deakin
\par E-mail: connor.deakin\@digipen.edu
\par Project: Graphics
\date 09/03/2017
\brief
  Contains the interface for the TextureSprite.
*/
/*****************************************************************************/

#ifndef TEXTURESPRITE_H
#define TEXTURESPRITE_H

#include "ShaderTexture.h"
#include "Texture.h"
#include "Sprite.h"

/*****************************************************************************/
/*!
\class TextureSprite
\brief
  The Sprite type used for displaying single textures. This will be displayed
  on a TextureGraphic
*/
/*****************************************************************************/
class TextureSprite : public Sprite
{
  public:
    TextureSprite(const ShaderTexture * shader,
                  const Texture * texture);
    virtual void Draw(const glm::mat4 & object_to_ndc) const;
    void SetTexture(const Texture * new_texture);
    void SetAdditive(bool is_additive);
  private:
    //! The shader used when drawing the Texture.
    const ShaderTexture * _shader;
    //! The texture that will be displayed.
    const Texture * _texture;
    //! Determines if the sprites color value is additive or multiplicative.
    bool _isAdditive;
};

#endif // !TEXTURESPRITE_H
