/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file TimedDestroy.cpp
\author Gabe Miller
\par E-mail: g.miller@digipen.edu
\par Project: Boat Game
\date 12/6/2016 1:45:22 PM
\brief

\par
Functions Include:
-
*/
/*****************************************************************************/

#include "TimedDestroy.h"
#include "Time.h"
#include "GameObjectManager.h"
#include "Object.h"


TimedDestroy::TimedDestroy(float time) : _lifetime(time), _time(0), Component("TimedDestroy")
{
}

void TimedDestroy::Update()
{
  _time += Time::DT();
  if (_time > _lifetime)
  {
    Owner().ObjectManager()->DeleteObject(&Owner());
  }
}

Component * CreateTimedDestroyComponent(Json::Value value)
{
  return new TimedDestroy(value["time"].asFloat());
}