/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#pragma once
/*****************************************************************************/
/*!
\file TimedDestroy.h
\author Gabe Miller
\par E-mail: g.miller\@digipen.edu
\par Project: Boat Game
\date 12/6/2016 1:44:22 PM
\brief
*/
/*****************************************************************************/

#ifndef TimedDestroy_H
#define TimedDestroy_H

#include "Component.h"

/*****************************************************************************/
/*!
\class TimedDestroy
\brief
  Destroys an object after a certain amount of time has passed.

\par
	Operations include:
	-

\deprecated
	-

\bug
	-
*/
/*****************************************************************************/
class TimedDestroy : public Component
{
public:
  TimedDestroy(float time);
  void Update();
private:
  const float _lifetime;
  float _time;
};


Component * CreateTimedDestroyComponent(Json::Value value);

#endif