/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#pragma once
/*****************************************************************************/
/*!
\file Vec2Math.h
\author Gabe Miller
\par E-mail: g.miller\@digipen.edu
\par Project: Boat Game
\date 10/6/2016
\brief
	This is the interface file for functions missing from the vec2 class.
*/
/*****************************************************************************/

#ifndef VEC2MATH_H
#define VEC2MATH_H

#include <glm/glm.hpp>

namespace Math
{
	
	float LengthSquared(glm::vec2 v);

	float DistanceSquared(glm::vec2 v, glm::vec2 w);

  float AngleBetweenSlow(glm::vec2 v, glm::vec2 w);

  float AngleBetweenFast(glm::vec2 v, glm::vec2 w);

  glm::vec2 RotateVector(glm::vec2 v, float angle);
}


#endif