/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
#include "WinScreen.h"
#include "InputManager.h"
#include "Space.h"
#include "Time.h"
#include "Graphics.h"
#include "AudioEngine.h"
#include "SpaceManager.h"

void WinScreen::Allocate()
{
  _objectManager.CreateArchetypeObjectAtPosition("winScreen", glm::vec3(0, 0, 0));
  Graphics::SetClearColor(0.1f, 0.1f, 0.1f, 1);

}

bool WinScreen::Update()
{
  _currentTime += Time::DT();
  if (!_soundPlayed && _currentTime > 4.0f) {
    audEngine.PauseAllChannels();
    audEngine.PlayAllChannels();
    audEngine.PlayEvent("event:/SFX/PlayerWin");
    _soundPlayed = true;
  }
  if (TheInputManager::Instance()->IsKeyPressed(SDL_SCANCODE_RETURN) ||
      TheInputManager::Instance()->getButtonState(0, SDL_CONTROLLER_BUTTON_A))
  {
    TransitionInfo transition_info(1.0f, 3.5f, MENU_MAIN);
    Global::SpaceManager::Add(transition_info);
  }

  return true;
}