/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file reader.cpp
\author Connor Deakin
\par E-mail: connor.deakin@digipen.edu
\par Project: Mecha
\date 27/09/2016
\brief
  Contains the implementation of the function in reader.h.

\par
    Functions Include:
    - read_file
*/
/*****************************************************************************/
#include "reader.h" 

#include <iostream> // cout, endl
#include <fstream> // ifstream
#include <string> // string

/*****************************************************************************/
/*!
\brief
  Use this to read an entire file into a single c++ string.

\param file_name
  The path to the file to be stored from the executable.

\return A standard string containing the contents of the file. A nullptr is
  returned if the file could not be opened.
*/
/*****************************************************************************/
std::string read_file(const char * file_name)
{
  //opening file
  std::ifstream file(file_name);
  if (!file.is_open())
  {
    std::cout << "Runtime Error: reader.cpp > readfile" << std::endl;
    std::cout << "  File cannot open: " << file_name << std::endl;
    return nullptr;
  }
  //copying over data
  std::string content;
  std::string line;
  std::getline(file, line);
  while (!file.eof())
  {
    content.append(line + "\n");
    std::getline(file, line);
  }
  return content;
}