/* All content(c) 2016 - 2017 DigiPen(USA) Corporation, all rights reserved. */
/*****************************************************************************/
/*!
\file spaceID.h
\author Connor Deakin
\par E-mail: connor.deakin@digipen.edu
\par Project: X-Craft
\date 01/12/2016
\brief
  Contains the type definition of a spaceID. This is here to prevent uneeded
  inludes when all that is needed is the spaceID type.
*/
/*****************************************************************************/

#ifndef SPACEID_H
#define SPACEID_H

#include <list>

//pre-declarations
class Space;

//! This type will be used to identify a Space. The SpaceManager::Add function
// will return an ID so you can use the ID to manipulate or Remove the Space.
// double derefrencing a spaceID will allow you to manipulate the Space and
// call Space functions. 
typedef std::list<Space *>::iterator spaceID;

#endif // !SPACEID_H

